Index: branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 530)
+++ branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal.c	(revision 531)
@@ -2980,193 +3626,239 @@
  * Try to load file from cache or download a remote file if not in cache
  */
-int loadRemoteFile(maps** m,map** content,HINTERNET* hInternet,char *url){
-  char* fcontent;
-  char* cached=isInCache(*m,url);
-  char *mimeType=NULL;
-  int fsize=0;
-  if(cached!=NULL){
-    struct stat f_status;
-    int s=stat(cached, &f_status);
-    if(s==0){
-      fcontent=(char*)malloc(sizeof(char)*(f_status.st_size+1));
-      FILE* f=fopen(cached,"rb");
-      fread(fcontent,f_status.st_size,1,f);
-      fsize=f_status.st_size;
-      fcontent[fsize]=0;
-      fclose(f);
-    }
-    cached[strlen(cached)-1]='m';
-    s=stat(cached, &f_status);
-    if(s==0){
-      mimeType=(char*)malloc(sizeof(char)*(f_status.st_size+1));
-      FILE* f=fopen(cached,"rb");
-      fread(mimeType,f_status.st_size,1,f);
-      mimeType[f_status.st_size]=0;
-      fclose(f);
-    }
-  }else{
-    hInternet->waitingRequests[hInternet->nb]=strdup(url);
-    InternetOpenUrl(hInternet,hInternet->waitingRequests[hInternet->nb],NULL,0,INTERNET_FLAG_NO_CACHE_WRITE,0);
-    return 0;
-  }
-  if(fsize==0){
-    return errorException(*m, _("Unable to download the file."), "InternalError",NULL);
-  }
-  if(mimeType!=NULL){
-    addToMap(*content,"fmimeType",mimeType);
-  }
-
-  map* tmpMap=getMapOrFill(content,"value","");
-    
-  free(tmpMap->value);
-  tmpMap->value=(char*)malloc((fsize+1)*sizeof(char));
-  if(tmpMap->value==NULL)
-    return errorException(*m, _("Unable to allocate memory."), "InternalError",NULL);
-  memcpy(tmpMap->value,fcontent,(fsize+1)*sizeof(char));
-  
+int
+loadRemoteFile (maps ** m, map ** content, HINTERNET * hInternet, char *url)
+{
+  char *fcontent;
+  char *cached = isInCache (*m, url);
+  char *mimeType = NULL;
+  int fsize = 0;
+  if (cached != NULL)
+    {
+      struct stat f_status;
+      int s = stat (cached, &f_status);
+      if (s == 0)
+        {
+          fcontent = (char *) malloc (sizeof (char) * (f_status.st_size + 1));
+          FILE *f = fopen (cached, "rb");
+          fread (fcontent, f_status.st_size, 1, f);
+          fsize = f_status.st_size;
+          fcontent[fsize] = 0;
+          fclose (f);
+        }
+      cached[strlen (cached) - 1] = 'm';
+      s = stat (cached, &f_status);
+      if (s == 0)
+        {
+          mimeType = (char *) malloc (sizeof (char) * (f_status.st_size + 1));
+          FILE *f = fopen (cached, "rb");
+          fread (mimeType, f_status.st_size, 1, f);
+          mimeType[f_status.st_size] = 0;
+          fclose (f);
+        }
+    }
+  else
+    {
+      hInternet->waitingRequests[hInternet->nb] = strdup (url);
+      InternetOpenUrl (hInternet, hInternet->waitingRequests[hInternet->nb],
+                       NULL, 0, INTERNET_FLAG_NO_CACHE_WRITE, 0);
+      return 0;
+    }
+  if (fsize == 0)
+    {
+      return errorException (*m, _("Unable to download the file."),
+                             "InternalError", NULL);
+    }
+  if (mimeType != NULL)
+    {
+      addToMap (*content, "fmimeType", mimeType);
+    }
+
+  map *tmpMap = getMapOrFill (content, "value", "");
+
+  free (tmpMap->value);
+  tmpMap->value = (char *) malloc ((fsize + 1) * sizeof (char));
+  if (tmpMap->value == NULL)
+    return errorException (*m, _("Unable to allocate memory."),
+                           "InternalError", NULL);
+  memcpy (tmpMap->value, fcontent, (fsize + 1) * sizeof (char));
+
   char ltmp1[256];
-  sprintf(ltmp1,"%d",fsize);
-  addToMap(*content,"size",ltmp1);
-  if(cached==NULL)
-    addToCache(*m,url,fcontent,mimeType,fsize);
+  sprintf (ltmp1, "%d", fsize);
+  addToMap (*content, "size", ltmp1);
+  if (cached == NULL)
+    addToCache (*m, url, fcontent, mimeType, fsize);
   else
-    addToMap(*content,"isCached","true");
-  free(fcontent);
-  free(mimeType);
-  free(cached);
+    addToMap (*content, "isCached", "true");
+  free (fcontent);
+  free (mimeType);
+  free (cached);
   return 0;
 }
 
-int errorException(maps *m, const char *message, const char *errorcode, const char *locator) 
-{
-  map* errormap = createMap("text", message);
-  addToMap(errormap,"code", errorcode);
-  if(locator!=NULL)
-    addToMap(errormap,"locator", locator);
+int
+errorException (maps * m, const char *message, const char *errorcode,
+                const char *locator)
+{
+  map *errormap = createMap ("text", message);
+  addToMap (errormap, "code", errorcode);
+  if (locator != NULL)
+    addToMap (errormap, "locator", locator);
   else
-    addToMap(errormap,"locator", "NULL");
-  printExceptionReportResponse(m,errormap);
-  freeMap(&errormap);
-  free(errormap);
+    addToMap (errormap, "locator", "NULL");
+  printExceptionReportResponse (m, errormap);
+  freeMap (&errormap);
+  free (errormap);
   return -1;
 }
 
 
-char *readVSIFile(maps* conf,const char* dataSource){
-    VSILFILE * fichier=VSIFOpenL(dataSource,"rb");
-    VSIStatBufL file_status;
-    VSIStatL(dataSource, &file_status);
-    if(fichier==NULL){
+char *
+readVSIFile (maps * conf, const char *dataSource)
+{
+  VSILFILE *fichier = VSIFOpenL (dataSource, "rb");
+  VSIStatBufL file_status;
+  VSIStatL (dataSource, &file_status);
+  if (fichier == NULL)
+    {
       char tmp[1024];
-      sprintf(tmp,"Failed to open file %s for reading purpose. File seems empty %d.",
-	      dataSource,file_status.st_size);
-      setMapInMaps(conf,"lenv","message",tmp);
+      sprintf (tmp,
+               "Failed to open file %s for reading purpose. File seems empty %d.",
+               dataSource, file_status.st_size);
+      setMapInMaps (conf, "lenv", "message", tmp);
       return NULL;
     }
-    char *res1=(char *)malloc(file_status.st_size*sizeof(char));
-    VSIFReadL(res1,1,file_status.st_size*sizeof(char),fichier);
-    res1[file_status.st_size-1]=0;
-    VSIFCloseL(fichier);
-    VSIUnlink(dataSource);
-    return res1;
-}
-
-void parseIdentifier(maps* conf,char* conf_dir,char *identifier,char* buffer){
+  char *res1 = (char *) malloc (file_status.st_size * sizeof (char));
+  VSIFReadL (res1, 1, file_status.st_size * sizeof (char), fichier);
+  res1[file_status.st_size - 1] = 0;
+  VSIFCloseL (fichier);
+  VSIUnlink (dataSource);
+  return res1;
+}
+
+void
+parseIdentifier (maps * conf, char *conf_dir, char *identifier, char *buffer)
+{
   char *saveptr1;
-  char *tmps1=strtok_r(identifier,".",&saveptr1);
-  int level=0;
+  char *tmps1 = strtok_r (identifier, ".", &saveptr1);
+  int level = 0;
   char key[25];
   char levels[18];
-  while(tmps1!=NULL){
-    char *test=zStrdup(tmps1);
-    char* tmps2=(char*)malloc((strlen(test)+2)*sizeof(char));
-    sprintf(key,"sprefix_%d",level);
-    sprintf(tmps2,"%s.",test);
-    sprintf(levels,"%d",level);
-    setMapInMaps(conf,"lenv","level",levels);
-    setMapInMaps(conf,"lenv",key,tmps2);
-    free(tmps2);
-    free(test);
-    level++;
-    tmps1=strtok_r(NULL,".",&saveptr1);
-  }
-  int i=0;
-  sprintf(buffer,"%s",conf_dir);
-  for(i=0;i<level;i++){
-    char *tmp0=zStrdup(buffer);
-    sprintf(key,"sprefix_%d",i);
-    map* tmp00=getMapFromMaps(conf,"lenv",key);
-    if(tmp00!=NULL)
-      sprintf(buffer,"%s/%s",tmp0,tmp00->value);
-    free(tmp0);
-    buffer[strlen(buffer)-1]=0;
-    if(i+1<level){
-      map* tmpMap=getMapFromMaps(conf,"lenv","metapath");
-      if(tmpMap==NULL || strlen(tmpMap->value)==0){
-	char *tmp01=zStrdup(tmp00->value);
-	tmp01[strlen(tmp01)-1]=0;
-	setMapInMaps(conf,"lenv","metapath",tmp01);
-	free(tmp01);
-	tmp01=NULL;
-      }
-      else{
-	if(tmp00!=NULL && tmpMap!=NULL){
-	  char *tmp00s=zStrdup(tmp00->value);
-	  tmp00s[strlen(tmp00s)-1]=0;
-	  char *value=(char*)malloc((strlen(tmp00s)+strlen(tmpMap->value)+2)*sizeof(char));
-	  sprintf(value,"%s/%s",tmpMap->value,tmp00s);
-	  setMapInMaps(conf,"lenv","metapath",value);
-	  free(value);
-	  free(tmp00s);
-	  value=NULL;
-	}
-      }
-    }else{
-      char *tmp01=zStrdup(tmp00->value);
-      tmp01[strlen(tmp01)-1]=0;
-      setMapInMaps(conf,"lenv","Identifier",tmp01);
-      free(tmp01);
-    }
-  }
-  char *tmp0=zStrdup(buffer);
-  sprintf(buffer,"%s.zcfg",tmp0);
-  free(tmp0);
-}
-
-int updateStatus( maps* conf, const int percentCompleted, const char* message ){
+  while (tmps1 != NULL)
+    {
+      char *test = zStrdup (tmps1);
+      char *tmps2 = (char *) malloc ((strlen (test) + 2) * sizeof (char));
+      sprintf (key, "sprefix_%d", level);
+      sprintf (tmps2, "%s.", test);
+      sprintf (levels, "%d", level);
+      setMapInMaps (conf, "lenv", "level", levels);
+      setMapInMaps (conf, "lenv", key, tmps2);
+      free (tmps2);
+      free (test);
+      level++;
+      tmps1 = strtok_r (NULL, ".", &saveptr1);
+    }
+  int i = 0;
+  sprintf (buffer, "%s", conf_dir);
+  for (i = 0; i < level; i++)
+    {
+      char *tmp0 = zStrdup (buffer);
+      sprintf (key, "sprefix_%d", i);
+      map *tmp00 = getMapFromMaps (conf, "lenv", key);
+      if (tmp00 != NULL)
+        sprintf (buffer, "%s/%s", tmp0, tmp00->value);
+      free (tmp0);
+      buffer[strlen (buffer) - 1] = 0;
+      if (i + 1 < level)
+        {
+          map *tmpMap = getMapFromMaps (conf, "lenv", "metapath");
+          if (tmpMap == NULL || strlen (tmpMap->value) == 0)
+            {
+              char *tmp01 = zStrdup (tmp00->value);
+              tmp01[strlen (tmp01) - 1] = 0;
+              setMapInMaps (conf, "lenv", "metapath", tmp01);
+              free (tmp01);
+              tmp01 = NULL;
+            }
+          else
+            {
+              if (tmp00 != NULL && tmpMap != NULL)
+                {
+                  char *tmp00s = zStrdup (tmp00->value);
+                  tmp00s[strlen (tmp00s) - 1] = 0;
+                  char *value =
+                    (char *)
+                    malloc ((strlen (tmp00s) + strlen (tmpMap->value) +
+                             2) * sizeof (char));
+                  sprintf (value, "%s/%s", tmpMap->value, tmp00s);
+                  setMapInMaps (conf, "lenv", "metapath", value);
+                  free (value);
+                  free (tmp00s);
+                  value = NULL;
+                }
+            }
+        }
+      else
+        {
+          char *tmp01 = zStrdup (tmp00->value);
+          tmp01[strlen (tmp01) - 1] = 0;
+          setMapInMaps (conf, "lenv", "Identifier", tmp01);
+          free (tmp01);
+        }
+    }
+  char *tmp0 = zStrdup (buffer);
+  sprintf (buffer, "%s.zcfg", tmp0);
+  free (tmp0);
+}
+
+int
+updateStatus (maps * conf, const int percentCompleted, const char *message)
+{
   char tmp[4];
-  snprintf(tmp,4,"%d",percentCompleted);
-  setMapInMaps( conf, "lenv", "status", tmp );
-  setMapInMaps( conf, "lenv", "message", message);
-  return _updateStatus( conf );
-}
-
-char* getInputValue( maps* inputs, const char* parameterName, size_t* numberOfBytes){
-  map* res=getMapFromMaps(inputs,parameterName,"value");
-  if(res!=NULL){
-    map* size=getMapFromMaps(inputs,parameterName,"size");
-    if(size!=NULL){
-      *numberOfBytes=(size_t)atoi(size->value);
-      return res->value;
-    }else{
-      *numberOfBytes=strlen(res->value);
-      return res->value;
-    }
-  }
+  snprintf (tmp, 4, "%d", percentCompleted);
+  setMapInMaps (conf, "lenv", "status", tmp);
+  setMapInMaps (conf, "lenv", "message", message);
+  return _updateStatus (conf);
+}
+
+char *
+getInputValue (maps * inputs, const char *parameterName,
+               size_t * numberOfBytes)
+{
+  map *res = getMapFromMaps (inputs, parameterName, "value");
+  if (res != NULL)
+    {
+      map *size = getMapFromMaps (inputs, parameterName, "size");
+      if (size != NULL)
+        {
+          *numberOfBytes = (size_t) atoi (size->value);
+          return res->value;
+        }
+      else
+        {
+          *numberOfBytes = strlen (res->value);
+          return res->value;
+        }
+    }
   return NULL;
 }
 
-int  setOutputValue( maps* outputs, const char* parameterName, char* data, size_t numberOfBytes ){
-  if(numberOfBytes==-1){
-    setMapInMaps(outputs,parameterName,"value",data);
-  }else{
-    char size[1024];
-    map* tmp=getMapFromMaps(outputs,parameterName,"value");
-    free(tmp->value);
-    tmp->value=(char*) malloc((numberOfBytes+1)*sizeof(char));
-    memcpy(tmp->value,data,numberOfBytes);
-    sprintf(size,"%lu",numberOfBytes);
-    setMapInMaps(outputs,parameterName,"size",size);
-  }
+int
+setOutputValue (maps * outputs, const char *parameterName, char *data,
+                size_t numberOfBytes)
+{
+  if (numberOfBytes == -1)
+    {
+      setMapInMaps (outputs, parameterName, "value", data);
+    }
+  else
+    {
+      char size[1024];
+      map *tmp = getMapFromMaps (outputs, parameterName, "value");
+      free (tmp->value);
+      tmp->value = (char *) malloc ((numberOfBytes + 1) * sizeof (char));
+      memcpy (tmp->value, data, numberOfBytes);
+      sprintf (size, "%lu", numberOfBytes);
+      setMapInMaps (outputs, parameterName, "size", size);
+    }
   return 0;
 }
Index: branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal_js.c
===================================================================
--- branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal_js.c	(revision 530)
+++ branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/service_internal_js.c	(revision 531)
@@ -32,61 +32,67 @@
 
 JSBool
-JSAlert(JSContext *cx, uintN argc, jsval *argv1)
-{
-  jsval *argv = JS_ARGV(cx,argv1);
-  int i=0;
-  JS_MaybeGC(cx);
-  for(i=0;i<argc;i++){
-    JSString* jsmsg = JS_ValueToString(cx,argv[i]);
-    char *tmp=JS_EncodeString(cx,jsmsg);
-    fprintf(stderr,"[ZOO-API:JS] %s\n",tmp);
-    free(tmp);
-  }
-  JS_MaybeGC(cx);
-  
+JSAlert (JSContext * cx, uintN argc, jsval * argv1)
+{
+  jsval *argv = JS_ARGV (cx, argv1);
+  int i = 0;
+  JS_MaybeGC (cx);
+  for (i = 0; i < argc; i++)
+    {
+      JSString *jsmsg = JS_ValueToString (cx, argv[i]);
+      char *tmp = JS_EncodeString (cx, jsmsg);
+      fprintf (stderr, "[ZOO-API:JS] %s\n", tmp);
+      free (tmp);
+    }
+  JS_MaybeGC (cx);
+
   return JS_TRUE;
 }
 
-JSBool 
-JSLoadScripts(JSContext *cx, uintN argc, jsval *argv1)
+JSBool
+JSLoadScripts (JSContext * cx, uintN argc, jsval * argv1)
 {
   //map* request = JS_GetContextPrivate(cx);
   //map* tmpm1=getMap(request,"metapath");
-  JS_MaybeGC(cx);
+  JS_MaybeGC (cx);
 
   char ntmp[1024];
-  getcwd(ntmp,1024);
-
-  jsval *argv = JS_ARGV(cx,argv1);
-  int i=0;
-  JS_MaybeGC(cx);
-  for(i=0;i<argc;i++){
-    JSString* jsmsg = JS_ValueToString(cx,argv[i]);
-    char *filename = JSValToChar(cx,&argv[i]);
-    char *api0=(char*)malloc((strlen(ntmp)+strlen(filename)+2)*sizeof(char));
-    sprintf(api0,"%s/%s",ntmp,filename);
-#ifdef JS_DEBUG
-    fprintf(stderr,"Trying to load %s\n",api0);
-    fflush(stderr);
-#endif
-    JSObject *api_script1=loadZooApiFile(cx,JS_GetGlobalObject(cx),api0);
-    free(api0);
-  }
-  JS_MaybeGC(cx);
-  JS_SET_RVAL(cx, argv1, JSVAL_VOID);
-  
+  getcwd (ntmp, 1024);
+
+  jsval *argv = JS_ARGV (cx, argv1);
+  int i = 0;
+  JS_MaybeGC (cx);
+  for (i = 0; i < argc; i++)
+    {
+      JSString *jsmsg = JS_ValueToString (cx, argv[i]);
+      char *filename = JSValToChar (cx, &argv[i]);
+      char *api0 =
+        (char *) malloc ((strlen (ntmp) + strlen (filename) + 2) *
+                         sizeof (char));
+      sprintf (api0, "%s/%s", ntmp, filename);
+#ifdef JS_DEBUG
+      fprintf (stderr, "Trying to load %s\n", api0);
+      fflush (stderr);
+#endif
+      JSObject *api_script1 =
+        loadZooApiFile (cx, JS_GetGlobalObject (cx), api0);
+      free (api0);
+    }
+  JS_MaybeGC (cx);
+  JS_SET_RVAL (cx, argv1, JSVAL_VOID);
+
   return JS_TRUE;
 }
 
 
-int zoo_js_support(maps** main_conf,map* request,service* s,
-		   maps **inputs,maps **outputs)
-{
-  maps* main=*main_conf;
-  maps* _inputs=*inputs;
-  maps* _outputs=*outputs;
+int
+zoo_js_support (maps ** main_conf, map * request, service * s,
+                maps ** inputs, maps ** outputs)
+{
+  maps *main = *main_conf;
+  maps *_inputs = *inputs;
+  maps *_outputs = *outputs;
 
   /* The class of the global object. */
-  JSClass global_class= {
+  JSClass global_class = {
     "global", JSCLASS_GLOBAL_FLAGS,
     JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_StrictPropertyStub,
@@ -98,239 +104,261 @@
   JSRuntime *rt;
   JSContext *cx;
-  JSObject  *global;
+  JSObject *global;
 
   /* Create a JS runtime. */
-  rt = JS_NewRuntime(8L * 1024L * 1024L);
+  rt = JS_NewRuntime (8L * 1024L * 1024L);
   if (rt == NULL)
     return 1;
-  
+
   /* Create a context. */
-  cx = JS_NewContext(rt,8192);
-  if (cx == NULL){
-    return 1;
-  }
-  JS_SetOptions(cx, JSOPTION_VAROBJFIX | JSOPTION_JIT | JSOPTION_METHODJIT);
-  JS_SetVersion(cx, JSVERSION_LATEST);
-  JS_SetErrorReporter(cx, reportError);
+  cx = JS_NewContext (rt, 8192);
+  if (cx == NULL)
+    {
+      return 1;
+    }
+  JS_SetOptions (cx, JSOPTION_VAROBJFIX | JSOPTION_JIT | JSOPTION_METHODJIT);
+  JS_SetVersion (cx, JSVERSION_LATEST);
+  JS_SetErrorReporter (cx, reportError);
 
   /* Create the global object. */
-  global = JS_NewCompartmentAndGlobalObject(cx, &global_class, NULL);
+  global = JS_NewCompartmentAndGlobalObject (cx, &global_class, NULL);
 
   /* Populate the global object with the standard globals,
      like Object and Array. */
-  if (!JS_InitStandardClasses(cx, global)){
-    return 1;
-  }
+  if (!JS_InitStandardClasses (cx, global))
+    {
+      return 1;
+    }
 
   /* Define specific function and global variable to share with JS runtime
    */
-  jsval tmp=INT_TO_JSVAL(3);
-  if (!JS_SetProperty(cx, global, "SERVICE_SUCCEEDED", &tmp))
-    return 1;
-  tmp=INT_TO_JSVAL(4);
-  if (!JS_SetProperty(cx, global, "SERVICE_FAILED", &tmp))
-    return 1;
-  if (!JS_DefineFunction(cx, global, "ZOORequest", JSRequest, 4, 0))
-    return 1;
-  if (!JS_DefineFunction(cx, global, "ZOOTranslate", JSTranslate, 4, 0))
-    return 1;
-  if (!JS_DefineFunction(cx, global, "ZOOUpdateStatus", JSUpdateStatus, 2, 0))
-    return 1;
-  if (!JS_DefineFunction(cx, global, "alert", JSAlert, 2, 0))
-    return 1;  
-  if (!JS_DefineFunction(cx, global, "importScripts", JSLoadScripts, 1, 0))
-    return 1;
+  jsval tmp = INT_TO_JSVAL (3);
+  if (!JS_SetProperty (cx, global, "SERVICE_SUCCEEDED", &tmp))
+      return 1;
+  tmp = INT_TO_JSVAL (4);
+  if (!JS_SetProperty (cx, global, "SERVICE_FAILED", &tmp))
+      return 1;
+  if (!JS_DefineFunction (cx, global, "ZOORequest", JSRequest, 4, 0))
+      return 1;
+  if (!JS_DefineFunction (cx, global, "ZOOTranslate", JSTranslate, 4, 0))
+      return 1;
+  if (!JS_DefineFunction
+      (cx, global, "ZOOUpdateStatus", JSUpdateStatus, 2, 0))
+      return 1;
+  if (!JS_DefineFunction (cx, global, "alert", JSAlert, 2, 0))
+      return 1;
+  if (!JS_DefineFunction (cx, global, "importScripts", JSLoadScripts, 1, 0))
+      return 1;
 
   /**
    * Add private context object
    */
-  void* cxPrivate = request;
-  JS_SetContextPrivate(cx,cxPrivate);
-
-  map* tmpm1=getMap(request,"metapath");
+  void *cxPrivate = request;
+  JS_SetContextPrivate (cx, cxPrivate);
+
   char ntmp[1024];
-  getcwd(ntmp,1024);
+  getcwd (ntmp, 1024);
 
   /**
    * Load the first part of the ZOO-API
    */
-  char *api0=(char*)malloc((strlen(ntmp)+17)*sizeof(char));
-  sprintf(api0,"%s/ZOO-proj4js.js",ntmp);
-#ifdef JS_DEBUG
-  fprintf(stderr,"Trying to load %s\n",api0);
-#endif
-  JSObject *api_script1=loadZooApiFile(cx,global,api0);
-  free(api0);
-  fflush(stderr);
-
-  char *api1=(char*)malloc((strlen(ntmp)+13)*sizeof(char));
-  sprintf(api1,"%s/ZOO-api.js",ntmp);
-#ifdef JS_DEBUG
-  fprintf(stderr,"Trying to load %s\n",api1);
-#endif
-  JSObject *api_script2=loadZooApiFile(cx,global,api1);
-  free(api1);
-  fflush(stderr);
+  char *api0 = (char *) malloc ((strlen (ntmp) + 17) * sizeof (char));
+  sprintf (api0, "%s/ZOO-proj4js.js", ntmp);
+#ifdef JS_DEBUG
+  fprintf (stderr, "Trying to load %s\n", api0);
+#endif
+  JSObject *api_script1 = loadZooApiFile (cx, global, api0);
+  free (api0);
+  fflush (stderr);
+
+  char *api1 = (char *) malloc ((strlen (ntmp) + 13) * sizeof (char));
+  sprintf (api1, "%s/ZOO-api.js", ntmp);
+#ifdef JS_DEBUG
+  fprintf (stderr, "Trying to load %s\n", api1);
+#endif
+  JSObject *api_script2 = loadZooApiFile (cx, global, api1);
+  free (api1);
+  fflush (stderr);
 
   /* Your application code here. This may include JSAPI calls
      to create your own custom JS objects and run scripts. */
-  maps* out=*outputs;
-  int res=SERVICE_FAILED;
-  maps* mc=*main_conf;
-  map* tmpm2=getMap(s->content,"serviceProvider");
-
-  char *filename=(char*)malloc(strlen(tmpm1->value)+strlen(tmpm2->value)+strlen(ntmp)+3);
-  sprintf(filename,"%s/%s/%s",ntmp,tmpm1->value,tmpm2->value);
-  filename[strlen(tmpm1->value)+strlen(tmpm2->value)+strlen(ntmp)+2]=0;
-#ifdef JS_DEBUG
-  fprintf(stderr,"FILENAME %s\n",filename);
+  maps *out = *outputs;
+  int res = SERVICE_FAILED;
+  maps *mc = *main_conf;
+  map *tmpm2 = getMap (s->content, "serviceProvider");
+  char *tmp_path = (char *) malloc ((strlen (s->zcfg) + 1) * sizeof (char *));
+  sprintf (tmp_path, "%s", s->zcfg);
+  char *dir = dirname (tmp_path);
+  char *filename =
+    (char *) malloc ((strlen (dir) + strlen (tmpm2->value) + 2) *
+                     sizeof (char *));
+  sprintf (filename, "%s/%s", dir, tmpm2->value);
+  free (tmp_path);
+#ifdef JS_DEBUG
+  fprintf (stderr, "FILENAME %s\n", filename);
 #endif
   struct stat file_status;
-  stat(filename, &file_status);
+  stat (filename, &file_status);
   //char *source=(char*)malloc(file_status.st_size);
   uint16 lineno;
   jsval rval;
-  JSBool ok ;
-  JSObject *script = JS_CompileFile(cx, global, filename);
-  if(script!=NULL){
-    (void)JS_ExecuteScript(cx, global, script, &rval);
-  }
-  else{
-    char tmp1[1024];
-    sprintf(tmp1,"Unable to load JavaScript file %s",filename);
-    free(filename);
-    map* err=createMap("text",tmp1);
-    addToMap(err,"code","NoApplicableCode");
-    printExceptionReportResponse(mc,err);
-    freeMap(&err);
-    free(err);
-    JS_MaybeGC(cx);
-    JS_DestroyContext(cx);
-    JS_DestroyRuntime(rt);
-    JS_ShutDown();
-    return -1;
-  }
-  
+  JSBool ok;
+  JSObject *script = JS_CompileFile (cx, global, filename);
+  if (script != NULL)
+    {
+      (void) JS_ExecuteScript (cx, global, script, &rval);
+    }
+  else
+    {
+      char tmp1[1024];
+      sprintf (tmp1, "Unable to load JavaScript file %s", filename);
+      free (filename);
+      map *err = createMap ("text", tmp1);
+      addToMap (err, "code", "NoApplicableCode");
+      printExceptionReportResponse (mc, err);
+      freeMap (&err);
+      free (err);
+      JS_MaybeGC (cx);
+      JS_DestroyContext (cx);
+      JS_DestroyRuntime (rt);
+      JS_ShutDown ();
+      return -1;
+    }
+
 
   /* Call a function in obj's scope. */
   jsval argv[3];
-  JSObject *jsargv1=JSObject_FromMaps(cx,*main_conf);
-  argv[0] = OBJECT_TO_JSVAL(jsargv1);
-  JSObject *jsargv2=JSObject_FromMaps(cx,*inputs);
-  argv[1] = OBJECT_TO_JSVAL(jsargv2);
-  JSObject *jsargv3=JSObject_FromMaps(cx,*outputs);
-  argv[2] = OBJECT_TO_JSVAL(jsargv3);
-  jsval rval1=JSVAL_NULL;
-#ifdef JS_DEBUG
-  fprintf(stderr, "object %p\n", (void *) argv[2]);
-#endif
-
-  ok = JS_CallFunctionName(cx, global, s->name, 3, argv, &rval1);
-
-#ifdef JS_DEBUG
-  fprintf(stderr, "object %p\n", (void *) argv[2]);
+  JSObject *jsargv1 = JSObject_FromMaps (cx, *main_conf);
+  argv[0] = OBJECT_TO_JSVAL (jsargv1);
+  JSObject *jsargv2 = JSObject_FromMaps (cx, *inputs);
+  argv[1] = OBJECT_TO_JSVAL (jsargv2);
+  JSObject *jsargv3 = JSObject_FromMaps (cx, *outputs);
+  argv[2] = OBJECT_TO_JSVAL (jsargv3);
+  jsval rval1 = JSVAL_NULL;
+#ifdef JS_DEBUG
+  fprintf (stderr, "object %p\n", (void *) argv[2]);
+#endif
+
+  ok = JS_CallFunctionName (cx, global, s->name, 3, argv, &rval1);
+
+#ifdef JS_DEBUG
+  fprintf (stderr, "object %p\n", (void *) argv[2]);
 #endif
 
   JSObject *d;
-  if (ok==JS_TRUE && JSVAL_IS_OBJECT(rval1)==JS_TRUE) {
-#ifdef JS_DEBUG
-    fprintf(stderr,"Function run sucessfully !\n");
-#endif
-    /* Should get a number back from the service function call. */
-    ok = JS_ValueToObject(cx, rval1, &d);
-  }else{
-    /* Unable to run JS function */
-    char tmp1[1024];
-    if(strlen(dbg)==0)
-      sprintf(dbg,"No result was found after the function call");
-    sprintf(tmp1,"Unable to run %s from the JavaScript file %s : \n %s",s->name,filename,dbg);
-#ifdef JS_DEBUG
-    fprintf(stderr,"%s",tmp1);
-#endif
-    map* err=createMap("text",tmp1);
-    addToMap(err,"code","NoApplicableCode");
-    printExceptionReportResponse(*main_conf,err);
-    freeMap(&err);
-    free(err);
-    free(filename);
-    JS_MaybeGC(cx);
-    JS_DestroyContext(cx);
-    JS_DestroyRuntime(rt);
-    JS_ShutDown();
-    // Should return -1 here but the unallocation won't work from zoo_service_loader.c line 1847
-    return -1;
-  }
-
-  jsval t=OBJECT_TO_JSVAL(d);
-  if(JS_IsArrayObject(cx,d)){
-#ifdef JS_DEBUG
-    fprintf(stderr,"An array was returned !\n");
-#endif
-    jsuint	 len;
-    if((JS_GetArrayLength(cx, d, &len)==JS_FALSE)){
-#ifdef JS_DEBUG
-      fprintf(stderr,"outputs array is empty\n");
-#endif
-    }
-    jsval tmp1;
-    JSBool hasResult=JS_GetElement(cx,d,0,&tmp1);
-    res=JSVAL_TO_INT(tmp1);
-#ifdef JS_DEBUG
-    fprintf(stderr," * %d * \n",res);
-#endif
-    if(res==SERVICE_SUCCEEDED){
-      jsval tmp2;
-      JSBool hasElement=JS_GetElement(cx,d,1,&tmp2);
-      if(hasElement==JS_TRUE){
-	freeMaps(outputs);
-	free(*outputs);
-	*outputs=mapsFromJSObject(cx,tmp2);
-      }
-    }else{
-      jsval tmp3;
-      JSBool hasConf=JS_GetElement(cx,d,1,&tmp3);
-      if(hasConf==JS_TRUE){
-	freeMaps(main_conf);
-	free(*main_conf);
-	*main_conf=mapsFromJSObject(cx,tmp3);
-      }
-    }
-
-  }
-  else{
-#ifdef JS_DEBUG
-    fprintf(stderr,"The service didn't return an array !\n");
+  if (ok == JS_TRUE && JSVAL_IS_OBJECT (rval1) == JS_TRUE)
+    {
+#ifdef JS_DEBUG
+      fprintf (stderr, "Function run sucessfully !\n");
+#endif
+      /* Should get a number back from the service function call. */
+      ok = JS_ValueToObject (cx, rval1, &d);
+    }
+  else
+    {
+      /* Unable to run JS function */
+      char tmp1[1024];
+      if (strlen (dbg) == 0)
+        sprintf (dbg, "No result was found after the function call");
+      sprintf (tmp1, "Unable to run %s from the JavaScript file %s : \n %s",
+               s->name, filename, dbg);
+#ifdef JS_DEBUG
+      fprintf (stderr, "%s", tmp1);
+#endif
+      map *err = createMap ("text", tmp1);
+      addToMap (err, "code", "NoApplicableCode");
+      printExceptionReportResponse (*main_conf, err);
+      freeMap (&err);
+      free (err);
+      free (filename);
+      JS_MaybeGC (cx);
+      JS_DestroyContext (cx);
+      JS_DestroyRuntime (rt);
+      JS_ShutDown ();
+      // Should return -1 here but the unallocation won't work from zoo_service_loader.c line 1847
+      return -1;
+    }
+
+  jsval t = OBJECT_TO_JSVAL (d);
+  if (JS_IsArrayObject (cx, d))
+    {
+#ifdef JS_DEBUG
+      fprintf (stderr, "An array was returned !\n");
+#endif
+      jsuint len;
+      if ((JS_GetArrayLength (cx, d, &len) == JS_FALSE))
+        {
+#ifdef JS_DEBUG
+          fprintf (stderr, "outputs array is empty\n");
+#endif
+        }
+      jsval tmp1;
+      JSBool hasResult = JS_GetElement (cx, d, 0, &tmp1);
+      res = JSVAL_TO_INT (tmp1);
+#ifdef JS_DEBUG
+      fprintf (stderr, " * %d * \n", res);
+#endif
+      if (res == SERVICE_SUCCEEDED)
+        {
+          jsval tmp2;
+          JSBool hasElement = JS_GetElement (cx, d, 1, &tmp2);
+          if (hasElement == JS_TRUE)
+            {
+              freeMaps (outputs);
+              free (*outputs);
+              *outputs = mapsFromJSObject (cx, tmp2);
+            }
+        }
+      else
+        {
+          jsval tmp3;
+          JSBool hasConf = JS_GetElement (cx, d, 1, &tmp3);
+          if (hasConf == JS_TRUE)
+            {
+              freeMaps (main_conf);
+              free (*main_conf);
+              *main_conf = mapsFromJSObject (cx, tmp3);
+            }
+        }
+
+    }
+  else
+    {
+#ifdef JS_DEBUG
+      fprintf (stderr, "The service didn't return an array !\n");
 #endif
     /**
      * Extract result
      */
-    jsval tmp1;
-    JSBool hasResult=JS_GetProperty(cx,d,"result",&tmp1);
-    res=JSVAL_TO_INT(tmp1);
-
-#ifdef JS_DEBUG
-    fprintf(stderr," * %d * \n",res);
+      jsval tmp1;
+      JSBool hasResult = JS_GetProperty (cx, d, "result", &tmp1);
+      res = JSVAL_TO_INT (tmp1);
+
+#ifdef JS_DEBUG
+      fprintf (stderr, " * %d * \n", res);
 #endif
     /**
      * Extract outputs when available.
      */
-    jsval tmp2;
-    JSBool hasElement=JS_GetProperty(cx,d,"outputs",&tmp2);
-    if(!JSVAL_IS_VOID(tmp2) && hasElement==JS_TRUE){
-      freeMaps(outputs);
-      free(*outputs);    
-      *outputs=mapsFromJSObject(cx,tmp2);
-    }
-    JS_MaybeGC(cx);
-#ifdef JS_DEBUG
-    if(JSVAL_IS_VOID(tmp2))
-      fprintf(stderr,"No outputs property returned\n");
-    else{
-      if(JS_IsArrayObject(cx,JSVAL_TO_OBJECT(tmp2)))
-	fprintf(stderr,"outputs is an array as expected\n");
+      jsval tmp2;
+      JSBool hasElement = JS_GetProperty (cx, d, "outputs", &tmp2);
+      if (!JSVAL_IS_VOID (tmp2) && hasElement == JS_TRUE)
+        {
+          freeMaps (outputs);
+          free (*outputs);
+          *outputs = mapsFromJSObject (cx, tmp2);
+        }
+      JS_MaybeGC (cx);
+#ifdef JS_DEBUG
+      if (JSVAL_IS_VOID (tmp2))
+        fprintf (stderr, "No outputs property returned\n");
       else
-	fprintf(stderr,"outputs is not an array as expected\n");
-    }
-    JS_MaybeGC(cx);
+        {
+          if (JS_IsArrayObject (cx, JSVAL_TO_OBJECT (tmp2)))
+            fprintf (stderr, "outputs is an array as expected\n");
+          else
+            fprintf (stderr, "outputs is not an array as expected\n");
+        }
+      JS_MaybeGC (cx);
 #endif
 
